Index: branches/network/src/lib/sound/sound_engine.cc
===================================================================
--- branches/network/src/lib/sound/sound_engine.cc	(revision 6092)
+++ branches/network/src/lib/sound/sound_engine.cc	(revision 6093)
@@ -290,9 +290,6 @@
   // INITIALIZING THE DEVICE:
 
-#ifdef AL_VERSION_1_1
+
   ALubyte deviceName[] =
-#else
-  ALCchar deviceName[] =
-#endif
 
 #ifdef __WIN32__
Index: branches/network/src/story_entities/network_world.cc
===================================================================
--- branches/network/src/story_entities/network_world.cc	(revision 6092)
+++ branches/network/src/story_entities/network_world.cc	(revision 6093)
@@ -17,5 +17,5 @@
 #define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD
 
-#include "world.h"
+#include "network_world.h"
 
 #include "shell_command.h"
@@ -75,12 +75,12 @@
 
 
-SHELL_COMMAND(speed, NetworkWorld, setSpeed);
-SHELL_COMMAND(togglePNodeVisibility, NetworkWorld, togglePNodeVisibility);
-SHELL_COMMAND(toggleBVVisibility, NetworkWorld, toggleBVVisibility);
+//SHELL_COMMAND(speed, NetworkWorld, setSpeed);
+//SHELL_COMMAND(togglePNodeVisibility, NetworkWorld, togglePNodeVisibility);
+//SHELL_COMMAND(toggleBVVisibility, NetworkWorld, toggleBVVisibility);
 
 using namespace std;
 
 //! This creates a Factory to fabricate a NetworkWorld
-CREATE_FACTORY(NetworkWorld, CL_WORLD);
+//CREATE_FACTORY(NetworkWorld, CL_WORLD);
 
 NetworkWorld::NetworkWorld(const TiXmlElement* root)
Index: branches/network/src/world_entities/spawning_point.cc
===================================================================
--- branches/network/src/world_entities/spawning_point.cc	(revision 6092)
+++ branches/network/src/world_entities/spawning_point.cc	(revision 6093)
@@ -17,11 +17,12 @@
 #include "spawning_point.h"
 #include "load_param.h"
-
+#include "factory.h"
+#include "compiler.h"
+#include "world.h" /* only temp. until the object manager is implemented*/
 
 /**
  *  standard constructor
  */
-SpawningPoint::SpawningPoint (const Vector& absCoordinate, const World* world)
-    : WorldEntity(absCoodrinate)
+SpawningPoint::SpawningPoint (World* world, const Vector& absCoordinate)
 {
   this->world = world;
@@ -37,6 +38,5 @@
  */
 SpawningPoint::SpawningPoint (const Vector& position, float frequency,
-                              float seed, int classID, const World* world)
-    : WorldEntity(position)
+                              float seed, ClassID classID, World* world)
 {
   this->frequency = frequency;
@@ -83,7 +83,7 @@
 
   /* now load the seed */
-  LoadParam(root, "classid", this, SpawningPoint, setSpawningEntity)
+/*  LoadParam(root, "classid", this, SpawningPoint, setSpawningEntity)
       .describe("sets the class id of the entity to spawn")
-      .defaultValues(1, CL_WORLD_ENTITY);
+      .defaultValues(1, CL_WORLD_ENTITY);*/
 }
 
@@ -97,5 +97,5 @@
             this->frequency, this->seed);
   BaseObject* spawningEntity = Factory::fabricate(this->classID);
-  if( LIKELY(this->world != NULL))
+  if( likely(this->world != NULL))
     this->world->spawn(dynamic_cast<WorldEntity*>(spawningEntity));
 }
Index: branches/network/src/world_entities/spawning_point.h
===================================================================
--- branches/network/src/world_entities/spawning_point.h	(revision 6092)
+++ branches/network/src/world_entities/spawning_point.h	(revision 6093)
@@ -17,6 +17,6 @@
 
   public:
-    SpawningPoint (const Vector& absCoordinate = Vector(0.0, 0.0, 0.0), const World* world);
-    SpawningPoint (const Vector& position, float frequency, float seed, int classID, const World* world);
+    SpawningPoint (World* world, const Vector& absCoordinate = Vector(0.0, 0.0, 0.0));
+    SpawningPoint (const Vector& position, float frequency, float seed, ClassID classID, World* world);
     virtual ~SpawningPoint ();
     void init();
@@ -25,5 +25,5 @@
 
     /**  sets the entity that is going to be spawned by this point @param classID: the id from the class_id.h file */
-    void SpawningPoint::setSpawningEntity(int classID) { this->classID = classID; }
+    void SpawningPoint::setSpawningEntity(ClassID classID) { this->classID = classID; }
     /** sets the frequency with which the point is going to spawn entities (1/sec) @param frequency: the frequency */
     void SpawningPoint::setSpawningFrequency(float frequency) { this->frequency = frequency; }
@@ -40,6 +40,6 @@
     float                countDown;                      //!< the timer that counts down until the next spawn
     float                seed;                           //!< the random seed of the position
-    int                  classID;                        //!< the classid of the entity to spawn
-
+    ClassID              classID;                        //!< the classid of the entity to spawn
+    World*               world;                          //!< reference to the world it belongs to (or in the future: the object manager)
 
 };