Index: /branches/network/src/lib/network/network_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_manager.cc	(revision 6095)
+++ /branches/network/src/lib/network/network_manager.cc	(revision 6096)
@@ -50,4 +50,5 @@
   this->tmpStream = NULL;
   this->hostID = -1;
+  this->bGameServer = false;
 
   PRINTF(0)("NetworkManager created\n");
Index: /branches/network/src/orxonox.cc
===================================================================
--- /branches/network/src/orxonox.cc	(revision 6095)
+++ /branches/network/src/orxonox.cc	(revision 6096)
@@ -353,8 +353,6 @@
   this->gameLoader = GameLoader::getInstance();
 
-  if( this->serverName != NULL)
-    this->gameLoader->loadNetworkCampaign("worlds/DefaultCampaign.oxc", NET_CLIENT);    /* start as client */
-  else if( this->port != -1)
-    this->gameLoader->loadNetworkCampaign("worlds/DefaultCampaign.oxc", NET_SERVER);    /* start as server */
+  if( this->port != -1)
+    this->gameLoader->loadNetworkCampaign("worlds/DefaultNetworkCampaign.oxc");
   else
     this->gameLoader->loadCampaign("worlds/DefaultCampaign.oxc");                       /* start orxonox in single player mode */
Index: /branches/network/src/story_entities/campaign.cc
===================================================================
--- /branches/network/src/story_entities/campaign.cc	(revision 6095)
+++ /branches/network/src/story_entities/campaign.cc	(revision 6096)
@@ -150,4 +150,5 @@
       delete (*it);
     }
+    PRINTF(1)("There is no StoryEnity left to play, quitting\n");
 }
 
Index: /branches/network/src/story_entities/network_world.cc
===================================================================
--- /branches/network/src/story_entities/network_world.cc	(revision 6095)
+++ /branches/network/src/story_entities/network_world.cc	(revision 6096)
@@ -75,12 +75,12 @@
 
 
-//SHELL_COMMAND(speed, NetworkWorld, setSpeed);
-//SHELL_COMMAND(togglePNodeVisibility, NetworkWorld, togglePNodeVisibility);
-//SHELL_COMMAND(toggleBVVisibility, NetworkWorld, toggleBVVisibility);
+SHELL_COMMAND(speed, NetworkWorld, setSpeed);
+SHELL_COMMAND(togglePNodeVisibility, NetworkWorld, togglePNodeVisibility);
+SHELL_COMMAND(toggleBVVisibility, NetworkWorld, toggleBVVisibility);
 
 using namespace std;
 
 //! This creates a Factory to fabricate a NetworkWorld
-//CREATE_FACTORY(NetworkWorld, CL_WORLD);
+CREATE_FACTORY(NetworkWorld, CL_WORLD);
 
 NetworkWorld::NetworkWorld(const TiXmlElement* root)
@@ -341,5 +341,5 @@
   // find WorldEntities //
   ////////////////////////
-  if( NetworkManager::getInstance()->isGameServer())
+  if( /*NetworkManager::getInstance()->isGameServer()*/1)
   {
     element = root->FirstChildElement("WorldEntities");
Index: /branches/network/src/util/loading/game_loader.cc
===================================================================
--- /branches/network/src/util/loading/game_loader.cc	(revision 6095)
+++ /branches/network/src/util/loading/game_loader.cc	(revision 6096)
@@ -122,5 +122,5 @@
  * this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
  */
-ErrorMessage GameLoader::loadNetworkCampaign(const char* fileName, int nodeState)
+ErrorMessage GameLoader::loadNetworkCampaign(const char* fileName)
 {
   ErrorMessage errorCode;
@@ -128,5 +128,5 @@
   if (campaignName)
   {
-    this->currentCampaign = this->fileToNetworkCampaign(campaignName, nodeState);
+    this->currentCampaign = this->fileToNetworkCampaign(campaignName);
     delete[] campaignName;
   }
@@ -296,5 +296,5 @@
  *  this will interprete the map/campaign files and recursivly load a tree of worlds/campaigns
  */
-Campaign* GameLoader::fileToNetworkCampaign(const char* fileName, int nodeState)
+Campaign* GameLoader::fileToNetworkCampaign(const char* fileName)
 {
   /* do not entirely load the campaign. just the current world
Index: /branches/network/src/util/loading/game_loader.h
===================================================================
--- /branches/network/src/util/loading/game_loader.h	(revision 6095)
+++ /branches/network/src/util/loading/game_loader.h	(revision 6096)
@@ -55,5 +55,5 @@
   ErrorMessage loadCampaign(const char* name);
   ErrorMessage loadDebugCampaign(Uint32 campaignID);
-  ErrorMessage loadNetworkCampaign(const char* fileName, int nodeState);
+  ErrorMessage loadNetworkCampaign(const char* fileName);
 
   void nextLevel();
@@ -67,5 +67,5 @@
 
   Campaign* fileToCampaign(const char* name);
-  Campaign* fileToNetworkCampaign(const char* fileName, int nodeState);
+  Campaign* fileToNetworkCampaign(const char* fileName);
 
 