Index: code/branches/particles2/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/particles2/src/orxonox/controllers/AIController.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/controllers/AIController.cc	(revision 6101)
@@ -109,5 +109,5 @@
 
         if (this->getControllableEntity() && this->bShooting_ && this->isCloseAtTarget(1000) && this->isLookingAtTarget(Ogre::Math::PI / 20.0f))
-//             this->getControllableEntity()->fire(0);
+            this->getControllableEntity()->fire(0);
 
         SUPER(AIController, tick, dt);
Index: code/branches/particles2/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/branches/particles2/src/orxonox/controllers/HumanController.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/controllers/HumanController.cc	(revision 6101)
@@ -145,5 +145,5 @@
     void HumanController::fire(unsigned int firemode)
     {
-        if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
+        if( HumanController::localController_s && HumanController::localController_s->controllableEntity_ )
             HumanController::localController_s->controllableEntity_->fire(firemode);
     }
Index: code/branches/particles2/src/orxonox/infos/PlayerInfo.cc
===================================================================
--- code/branches/particles2/src/orxonox/infos/PlayerInfo.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/infos/PlayerInfo.cc	(revision 6101)
@@ -51,6 +51,5 @@
         this->controllableEntity_ = 0;
         this->controllableEntityID_ = OBJECTID_UNKNOWN;
-        this->temporaryControllableEntity_ = 0;
-        this->temporaryControllableEntityID_ = OBJECTID_UNKNOWN;
+        this->oldControllableEntity_ = 0;
 
         this->gtinfo_ = 0;
@@ -82,6 +81,4 @@
         registerVariable(this->name_,                 VariableDirection::ToClient, new NetworkCallback<PlayerInfo>(this, &PlayerInfo::changedName));
         registerVariable(this->controllableEntityID_, VariableDirection::ToClient, new NetworkCallback<PlayerInfo>(this, &PlayerInfo::networkcallback_changedcontrollableentityID));
-        registerVariable(this->temporaryControllableEntityID_, VariableDirection::ToClient, new NetworkCallback<PlayerInfo>(this, &PlayerInfo::networkcallback_changedcontrollableentityID));
-        registerVariable(this->bReadyToSpawn_,        VariableDirection::ToServer);
         registerVariable(this->gtinfoID_,             VariableDirection::ToClient, new NetworkCallback<PlayerInfo>(this, &PlayerInfo::networkcallback_changedgtinfoID));
     }
@@ -151,4 +148,6 @@
             return;
 
+        if (this->oldControllableEntity_)
+            this->stopTemporaryControl();
         if (this->controllableEntity_)
             this->stopControl();
@@ -172,13 +171,12 @@
             return;
         
-        assert( this->temporaryControllableEntity_==0 );
-
-        this->temporaryControllableEntity_ = entity;
-        this->temporaryControllableEntityID_ = entity->getObjectID();
+//         assert( this->temporaryControllableEntity_==0 );
+
+        this->oldControllableEntity_ = this->controllableEntity_;
+        this->controllableEntity_ = entity;
+        this->controllableEntityID_ = entity->getObjectID();
 
         entity->setPlayer(this);
 
-        this->bReadyToSpawn_ &= (!this->bSetUnreadyAfterSpawn_);
-
         if (this->controller_)
             this->controller_->setControllableEntity(entity);
@@ -189,4 +187,7 @@
     void PlayerInfo::stopControl()
     {
+        if ( this->oldControllableEntity_ )
+            this->stopTemporaryControl();
+        
         ControllableEntity* entity = this->controllableEntity_;
 
@@ -200,5 +201,6 @@
             this->controller_->setControllableEntity(0);
 
-        entity->removePlayer();
+        if ( GameMode::isMaster() )
+            entity->removePlayer();
 
         this->changedControllableEntity();
@@ -207,16 +209,18 @@
     void PlayerInfo::stopTemporaryControl()
     {
-        ControllableEntity* entity = this->temporaryControllableEntity_;
-
-        if (!entity)
-            return;
-
-        this->temporaryControllableEntity_ = 0;
-        this->temporaryControllableEntityID_ = OBJECTID_UNKNOWN;
+        ControllableEntity* entity = this->controllableEntity_;
+
+        if (!entity || !this->oldControllableEntity_)
+            return;
+
+        this->controllableEntity_ = this->oldControllableEntity_;
+        this->controllableEntityID_ = this->controllableEntity_->getObjectID();
+        this->oldControllableEntity_ = 0;
 
         if ( this->controllableEntity_ && this->controller_)
             this->controller_->setControllableEntity(this->controllableEntity_);
 
-        entity->removePlayer();
+        if ( GameMode::isMaster() )
+            entity->removePlayer();
         
         this->changedControllableEntity();
@@ -237,23 +241,7 @@
     }
 
-    void PlayerInfo::networkcallback_changedtemporarycontrollableentityID()
-    {
-        CCOUT(0) << "changedtemporarycontrollableentityid" << endl;
-        if (this->temporaryControllableEntityID_ != OBJECTID_UNKNOWN)
-        {
-            Synchronisable* temp = Synchronisable::getSynchronisable(this->temporaryControllableEntityID_);
-            ControllableEntity* entity = orxonox_cast<ControllableEntity*>(temp);
-            this->startTemporaryControl(entity);
-        }
-        else
-        {
-            this->stopTemporaryControl();
-        }
-    }
-
 
     void PlayerInfo::networkcallback_changedgtinfoID()
     {
-        CCOUT(0) << "changedcontrollableentityid" << endl;
         if (this->gtinfoID_ != OBJECTID_UNKNOWN)
         {
Index: code/branches/particles2/src/orxonox/infos/PlayerInfo.h
===================================================================
--- code/branches/particles2/src/orxonox/infos/PlayerInfo.h	(revision 6087)
+++ code/branches/particles2/src/orxonox/infos/PlayerInfo.h	(revision 6101)
@@ -92,5 +92,4 @@
         private:
             void networkcallback_changedcontrollableentityID();
-            void networkcallback_changedtemporarycontrollableentityID();
             void networkcallback_changedgtinfoID();
             void updateGametypeInfo();
@@ -99,7 +98,6 @@
             Controller* controller_;
             ControllableEntity* controllableEntity_;
-            ControllableEntity* temporaryControllableEntity_;
+            ControllableEntity* oldControllableEntity_;
             unsigned int controllableEntityID_;
-            unsigned int temporaryControllableEntityID_;
 
             const GametypeInfo* gtinfo_;
Index: code/branches/particles2/src/orxonox/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/ControllableEntity.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/ControllableEntity.cc	(revision 6101)
@@ -36,4 +36,5 @@
 #include "core/GameMode.h"
 #include "core/XMLPort.h"
+#include "network/NetworkFunction.h"
 
 #include "Scene.h"
@@ -47,4 +48,6 @@
 {
     CreateFactory(ControllableEntity);
+
+    registerMemberNetworkFunction( ControllableEntity, fire );
 
     ControllableEntity::ControllableEntity(BaseObject* creator) : MobileEntity(creator)
@@ -217,4 +220,16 @@
             this->cameraPositionRootNode_->roll(Radian(value.y * this->mouseLookSpeed_), Ogre::Node::TS_LOCAL);
     }
+    
+    void ControllableEntity::fire(unsigned int firemode)
+    {
+        if(GameMode::isMaster())
+        {
+            this->fired(firemode);
+        }
+        else
+        {
+            callMemberNetworkFunction(ControllableEntity, fire, this->getObjectID(), 0, firemode);
+        }
+    }
 
     void ControllableEntity::setPlayer(PlayerInfo* player)
Index: code/branches/particles2/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/ControllableEntity.h	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/ControllableEntity.h	(revision 6101)
@@ -84,5 +84,6 @@
                 { this->rotateRoll(Vector2(value, 0)); }
 
-            virtual void fire(unsigned int firemode) {}
+            void fire(unsigned int firemode);
+            virtual void fired(unsigned int firemode) {}
             virtual void reload() {}
 
Index: code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.cc
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.cc	(revision 6101)
@@ -52,6 +52,4 @@
     CreateFactory(Pawn);
 
-    registerMemberNetworkFunction( Pawn, doFire );
-
     Pawn::Pawn(BaseObject* creator) : ControllableEntity(creator)
     {
@@ -263,22 +261,8 @@
     }
 
-    void Pawn::fire(unsigned int firemode)
-    {
-        this->doFire(firemode);
-    }
-
-    void Pawn::doFire(uint8_t firemode)
-    {
-        if(GameMode::isMaster())
-        {
-            if (this->weaponSystem_)
-                this->weaponSystem_->fire(firemode);
-        }
-        else
-        {
-            callMemberNetworkFunction(Pawn, doFire, this->getObjectID(), 0, firemode);
-            if (this->weaponSystem_)
-                this->weaponSystem_->fire(firemode);
-        }
+    void Pawn::fired(unsigned int firemode)
+    {
+        if (this->weaponSystem_)
+            this->weaponSystem_->fire(firemode);
     }
 
Index: code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.h
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.h	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/pawns/Pawn.h	(revision 6101)
@@ -79,7 +79,6 @@
             virtual void kill();
 
-            virtual void fire(unsigned int firemode);
+            virtual void fired(unsigned int firemode);
             virtual void reload();
-            virtual void doFire(uint8_t firemode);
             virtual void postSpawn();
 
Index: code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.cc
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.cc	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.cc	(revision 6101)
@@ -189,5 +189,5 @@
     }
 
-    void Spectator::fire(unsigned int firemode)
+    void Spectator::fired(unsigned int firemode)
     {
         if (this->getPlayer())
Index: code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.h
===================================================================
--- code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.h	(revision 6087)
+++ code/branches/particles2/src/orxonox/worldentities/pawns/Spectator.h	(revision 6101)
@@ -55,5 +55,5 @@
             virtual void rotateRoll(const Vector2& value);
 
-            virtual void fire(unsigned int firemode);
+            virtual void fired(unsigned int firemode);
             virtual void greet();
 